'IOmkII_01
'PCB X1 Test01 Init AVR and blink LEDs
'
'Peter J. Stonard
'August 25, 2008
'
'******************************************************************************
'* Hardware Definition Atmel ATmega8AU (TQFP32)                               *
'******************************************************************************
'Port A
'PA7 = OUT1 'Drive to channel1
'PA6 = OUT2
'PA5 = OUT3
'PA4 = OUT4
'PA3 = OUT5
'PA2 = OUT6
'PA1 = OUT7
'PA0 = OUT8
'
'Port B
'PB7 = RESET
'PB6 = A2
'PB5 = A1
'PB4 = A0
'PB3 = Tp Trig
'PB2 = SCK/SCL
'PB1 = MISO
'PB0 = MOSI/SDA
'
'******************************************************************************
'* Define Variables                                                           *
'******************************************************************************
Dim 1ms_flg As Bit
Dim Seed0 As Byte
Dim Tmpa As Byte
Dim Tmpb As Byte
Dim Tmpc As Byte
Dim Tmpd As Byte
Dim Tick As Word
'******************************************************************************
'* Init Values                                                                *
'******************************************************************************
Porta = &HFF
'Seed0 = 118                             'Timer0 seed /64 clk for 1ms int
Seed0 = 186                             'Timer0 seed /256 clk for 2ms int
'******************************************************************************
'* Alias                                                                      *
'******************************************************************************
'Digit data:
Out1 Alias Porta.7
Out2 Alias Porta.6
Out3 Alias Porta.5
Out4 Alias Porta.4
Out5 Alias Porta.3
Out6 Alias Porta.2
Out7 Alias Porta.1
Out8 Alias Porta.0

A2 Alias Portb.6
A1 Alias Portb.5
A0 Alias Portb.4
Trig Alias Portb.3
'
'******************************************************************************
'* Define Subroutines                                                         *
'******************************************************************************

'******************************************************************************
'* Define AVR                                                                 *
'******************************************************************************
$regfile = "attiny26.dat"               'Change for your AVR.
$crystal = 8000000                      '8 MHz Crystal.
'
'******************************************************************************
'* Define I2C pins                                                            *
'******************************************************************************
Config Sda = Portb.0                    ' I2C Data
Config Scl = Portb.2                    ' I2C Clock
'
'******************************************************************************
'* Define Ports & Data Direction registers  (In = 0, Out = 1)                 *                                               *
'******************************************************************************
'Port A
Porta = &B0000_0000                     ' Set All Port Pins Low
Ddra = &B1111_1111                      ' Set Unused Pins As Outputs.

'Port B
Portb = &B0000_0000                     ' Set All Port Pins Low
Ddrb = &B0000_0000                      ' Set Unused Pins As Outputs.
'
'******************************************************************************
'* Main Program                                                               *
'******************************************************************************
Main:
Config Timer0 = Timer , Prescale = 256  'timer1 generates strobe int
Load Timer0 , Seed0
'
Enable Timer0
On Timer0 Timer0_isr
'
Enable Interrupts                       'Enable interrupts
'
Porta = &HFF
Tmpb = &H01
Do
If 1ms_flg = 1 Then

   Toggle Trig
   Incr Tmpa
   If Tmpa = 100 Then Tmpa = &H00       '100ms timer
'
If Tmpa = &H00 Then
'   Tmpc = Pinb                          'Read address switches
'   Tmpc = Tmpc And &H70                 'Mask address bits
'   Porta = Not Tmpc                     'sent to LEDs
'
   Rotate Tmpb , Right
   Porta = Not Tmpb
   End If
'
1ms_flg = 0
End If

'
Loop
'
'******************************************************************************
'* ISR                                                                        *
'******************************************************************************
Timer0_isr:
Timer0 = Seed0
Set 1ms_flg
Return
'
'******************************************************************************
'* Subroutines                                                                *
'******************************************************************************

'******************************************************************************
End                                     'end program                          *
'******************************************************************************